'use strict';

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _immutable = require('immutable');

var _immutable2 = _interopRequireDefault(_immutable);

var _TextTransform = require('./TextTransform');

var _TextTransform2 = _interopRequireDefault(_TextTransform);

var _ImageTransform = require('./ImageTransform');

var _ImageTransform2 = _interopRequireDefault(_ImageTransform);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Transformime = (function () {
  function Transformime() {
    _classCallCheck(this, Transformime);

    this.transforms = new _immutable2.default.Map({
      'text/plain': _TextTransform2.default,
      'image/png': _ImageTransform2.default,
      'image/jpeg': _ImageTransform2.default,
      'image/svg+xml': _ImageTransform2.default
    });

    this.displayOrder = new _immutable2.default.List(['application/javascript', 'text/html', 'text/markdown', 'text/latex', 'image/svg+xml', 'image/png', 'image/jpeg', 'application/pdf', 'text/plain']);
  }

  /**
   * Transforms a mime bundle, using the richest available representation,
   * into React Component.
   * @param  {Immutable.Map}   bundle - Map({mimetype1: data1, mimetype2: data2, ...})
   * @return {React.Component} Richest mimetype as a React Component
   */

  _createClass(Transformime, [{
    key: 'transform',
    value: function transform(bundle) {
      var _this = this;

      var richestMimetype = bundle.keySeq().sortBy(function (mimetype) {
        return _this.displayOrder.indexOf(mimetype);
      }).first();

      var t = _react2.default.createFactory(this.transforms.get(richestMimetype));
      return t({ data: bundle.get(richestMimetype), mimetype: richestMimetype });
    }
  }]);

  return Transformime;
})();

exports.default = Transformime;
//# sourceMappingURL=Transformime.js.map